
module controler(

	reset,			// Input system clock
	clock,			// Input system reset
	start,			// Input value of start

	count,        	// Output value of CNT
	select,     	// Output value of select
	End				// Output value of END
	
);

	//Input
	input  				reset;
	input  				clock;
	input  				start;

	//Outputs
	output		[3:0]	count;  
   	output				select;
   	output				End;	

	//Reg
	reg			[3:0]	count;
   	reg					count_en;
	reg					End;

	//Wire
	wire					select;

	assign		select = start;

	always @(posedge clock	or	negedge	reset)
	begin
		if(reset == 1'b0) begin
				count_en	<=	0;
		end
		else begin
			if(count == 13) begin
				count_en	<=	0;
			end
			else if(start) begin
				count_en <=	1;
			end
			else begin
				count_en	<=	count_en;
			end
		end
	end

	always @(posedge clock	or	negedge	reset)
	begin
		if(reset == 1'b0) begin
				count	<=	0;
		end
		else begin
			if(count == 13) begin
				count	<=	0;
			end
			else if (count_en) begin
				count <=	count + 1;
			end
			else if(start) begin
				count <=	1;
			end
			else begin
				count	<=	0;
			end
		end
	end

	always @(posedge clock	or	negedge	reset)
		begin
			if(reset == 1'b0) begin
				End		<=	0;
				
			end
			else begin
				if(count == 13) begin
					End	<=	1;
				end
				else begin
					End	<=	0;
				end
			end
		end

endmodule
