
module cordic(
	clock,			// Input system clock
	reset,			// Input system reset
	start,			// Input system start
	theta_in,		// Input value of theta

	x_init,			// Initial value of x
	y_init,         // Initial value of y
	z_init,         // Initial value of z

	x_out,			// Output value of x
	y_out,			// Output value of y
	z_out, 			// Output value of z
	End				// Output value of End
);


	input		signed	[15:0]	x_init;
   	input   	signed	[15:0]	y_init;
   	input   	signed	[15:0]	z_init;
  	input   	signed	[15:0]	theta_in;
	input						clock;
	input						reset;
	input						start;


	output		signed	[15:0]	x_out;	
	output		signed	[15:0]	y_out;	
	output		signed	[15:0]	z_out;
	output   						End;

	wire		signed	[31:0]	theta;
	wire		signed	[15:0]	PI;
	wire		signed	[15:0]	theta_out;
	wire				[3:0]	ADDRESS;
	wire						SELECT;

	
	assign	PI = 16'b0110010010000111;
	assign	theta = theta_in*PI;
	assign	theta_out = theta[28:13];


controler u_controler(
	
	.reset			(	reset	),				// Input system clock
	.clock			(	clock	),				// Input system reset
	.start			(	start	),				// Input value of start
	.count			(	ADDRESS	),       		// Output value of CNT
	.select			(	SELECT	),     			// Output value of select
	.End			(	End		)				// Output value of END
	
);


cordic_data u_cordic_data(
	.clock			(	clock	),				// Input system clock
	.reset			(	reset	),				// Input system reset
	.End			(	End		),				// Input system End
	.theta_in		(	theta_out	),			// Input value of theta
	.x_init			(	x_init	),				// Initial value of x
	.y_init			(	y_init	),       		// Initial value of y
	.z_init			(	z_init	),       		// Initial value of z
	.select			(	SELECT	),				// Input value of select
	.address		(	ADDRESS	),				// Input value of address
	.x_out			(	x_out	),				// Output value of x
	.y_out			(  y_out	),				// Output value of y
	.z_out			(	z_out	) 				// Output value of z
);



endmodule
