
module cordic_check (
	alpha_in, 		// Input  value of alpha
	delta_in, 		// Input  value of delta
	theta_in, 		// Input  value of theta
	z_in,     		// Input  value of z
	alpha_out, 		// Output value of alpha
	delta_out		// Output value of delta
);            		

	//Inputs
	input		signed	[15:0]	delta_in;
	input		signed	[15:0]	alpha_in;
	input	 	signed	[15:0]	theta_in;
	input  		signed	[15:0]	z_in;

	//Outputs
   	output		signed	[15:0]	delta_out;
   	output		signed	[15:0]	alpha_out;

	//Check z_in and decide to whether invert alpha or not
	assign alpha_out = alpha_check( alpha_in, theta_in, z_in);

	//Check z_in and decide to whether invert delta or not
	assign delta_out = delta_check( delta_in, theta_in, z_in);

	//wether input z_in is larger than theta or not
	function  	signed 	[15:0]	alpha_check;
        input	signed	[15:0]	alpha_in;
        input	signed	[15:0]	theta_in;
        input  	signed	[15:0]	z_in;

		if(z_in > theta_in) begin
			alpha_check = -alpha_in;
		end
		else begin
			alpha_check = alpha_in;
		end
	endfunction

	//wether input z_in is larger than theta or not
	function 	signed	[15:0]	delta_check;
        input	signed	[15:0]	delta_in;
        input	signed	[15:0]	theta_in;
        input  	signed	[15:0]	z_in;

		if(z_in > theta_in) begin
			delta_check = -delta_in;
		end
		else begin
			delta_check = delta_in;
		end
	endfunction

endmodule

