
module codric_init_SLT (
	select,			// Select as output value from X_init or X_in
	x_init,			// Initial value of x
	y_init,			// Initial value of y
	z_init,			// Initial value of z
	x_in,			// Itarated value of x
	y_in,			// Itarated value of y
	z_in,			// Itarated value of z
	x_out,			// Selected value of x
	y_out,			// Selected value of y
	z_out 			// Selected value of z
);

	//Inputs
	input		signed	[15:0]	x_init;
	input		signed	[15:0]	y_init;
	input		signed	[15:0]	z_init;
	input   	signed	[15:0]	x_in;
	input   	signed	[15:0]	y_in;
	input   	signed	[15:0]	z_in;
	input						select;

	//Inputs
	output		signed	[15:0]	x_out;
	output		signed	[15:0]	y_out;
	output		signed	[15:0]	z_out;

	// Wires
	wire		signed	[15:0]	x_out;
	wire		signed	[15:0]	y_out;
	wire		signed	[15:0]	z_out;

	// Select as output value from x_init or x_in
	assign x_out = selector_v( x_init, x_in, select);

	// Select as output value from y_init or y_in
	assign y_out = selector_v( y_init, y_in, select);

	// Select as output value from z_init or z_in
	assign z_out = selector_v( z_init, z_in, select);

	// Select as output value from *_init or *_in
	function signed	[15:0] selector_v;
		input		signed	[15:0]	v_init;
		input		signed	[15:0]	v_in;
		input								select;
		
		if (select) begin
			selector_v = v_init;
		end else begin
			selector_v = v_in;
		end
	endfunction

endmodule

