
module sin_cos_cordic(
	clock,			// Input system clock
	reset,			// Input system reset
	start,			// Input system start
	theta_in,		// Input value of theta
	cos_out,		// Output value of x
	sin_out,		// Output value of y
	End				// Output value of End
);


	input						clock;
   	input   					reset;
   	input   					start;
   	input   	signed	[15:0]	theta_in;


   	output  	signed	[15:0]	cos_out;		
   	output  	signed	[15:0]	sin_out;
	output						End;


	wire		signed	[15:0]	cos_out;
	wire		signed	[15:0]	sin_out;
	wire						End;


cordic u_cordic(
	.clock			(	clock		),				// Input system clock
	.reset			(	reset		),				// Input system reset
	.start			(	start		),				// Input system start
	.theta_in		(	theta_in	),				// Input value of theta
	.x_init			(	16'b0010011011011101	),	// Initial value of x
	.y_init			(	16'b0000000000000000	),  // Initial value of y
	.z_init			(	16'b0000000000000000	),  // Initial value of z
	.x_out			(	cos_out	),					// Output value of x
	.y_out			(	sin_out	),					// Output value of y
	.z_out			(	),							// Output value of z
	.End			(	End	)						// Output value of End
);


endmodule

