`timescale 1ns / 1ns

module cordic_tb;

	//Inputs
   	reg							clock;
   	reg							reset;
   	reg							start;
   	reg			signed	[15:0]	theta_in;

	//Outputs
	wire		signed	[15:0]	x_out;
   	wire    	signed	[15:0]	y_out;
   	wire   						End;

	parameter STEP = 1000;


sin_cos_cordic u_sin_cos_cordic(
	clock,			// Input system clock
	reset,			// Input system reset
	start,			// Input system start
	theta_in,		// Input value of theta
	x_out,			// Output value of x
	y_out,			// Output value of y
	End
);


	always #(STEP/2) clock = ~clock;

	initial begin
		//initialize
		#0		reset = 0;	
				clock = 0;
				start = 0;
				theta_in	= 0;

		#(STEP)	//theta_in is PI/4 value
				theta_in	= 16'b0001000000000000;
				//theta_in is PI1/8 value
               	//theta_in	= 16'b0000100000000000;		
				//theta_in is PI2/8 value
               	//theta_in	= 16'b0001000000000000;
				//theta_in is PI3/8 value
               	//theta_in	= 16'b0001100000000000;
				//theta_in is PI4/8 value
               	//theta_in	= 16'b0010000000000000;
				//theta_in is -PI1/8 value
               	//theta_in	= 16'b1111100000000000;
				//theta_in is -PI2/8 value
               	//theta_in	= 16'b1111000000000000;
				//theta_in is -PI3/8 value
               	//theta_in	= 16'b1110100000000000;
				//theta_in is -PI4/8 value
               	//theta_in	= 16'b1110000000000000;
				//theta_in is 0 value
               	//theta_in	= 16'b0000000000000000;
				//theta_in is 1/128 value
               	//theta_in	= 16'b0000000010000000;
				//theta_in is 1/256 value
               	//theta_in	= 16'b0000000001000000;
				//theta_in is -1/128 value
               	//theta_in	= 16'b1111111110000000;
				//theta_in is -1/256 value
               	//theta_in	= 16'b1111111111000000;
				//theta_in is PI4/8 - 1/128 value
               	//theta_in	= 16'b0001111111010111;
				//theta_in is PI4/8 - 1/256 value
               	//theta_in	= 16'b0001111111101011;
				//theta_in is -PI4/8 + 1/128 value
               	//theta_in	= 16'b1110000000101001;
				//theta_in is -PI4/8 + 1/256 value
               	//theta_in	= 16'b1110000000010101;
					
					
				reset = 1;	
		
		#(STEP)	start = 1;
		#(STEP)	start	= 0;
		#(STEP*14)

		$finish;
	end

	initial
		$monitor ( $stime,"theta_in = %b x_out = %b y_out = %b End = %b",theta_in, x_out, y_out, End);
		
endmodule